#include "StdAfx.h"
#include "Scoala.h"

#include <iostream>

using namespace std;

bool SchoolsGenerator::generate()
{
 	FILE *f; //Voronoi file
	char s[256];
  int nr_scoli;

  f = fopen(_voronoiFileName.c_str(),"r"); 
	if (f == NULL) 
	{
    std::cout << "Input file = " << _voronoiFileName.c_str() << "could not be found" <<endl;
    return false;
	}
	else 
	{
    std::cout <<"Reading file = " << _voronoiFileName.c_str() << "...." << endl;
	};
	

	fgets(s,256,f);
	fgets(s,256,f);
	sscanf_s(s,"%d",&nr_scoli);
	
	
	for (int i=1; i<=7&& !feof(f);i++) 
	{
		fgets(s,256,f); 
	};

	if (feof(f)) 
	{
		cout << "Unexpected end of file" << endl;
    return false;
	};

	vectorScoli.resize(nr_scoli);
	
	for (int i=0; i<nr_scoli && !feof(f); i++) 
	{
		
	
		fgets(s,256,f);
		sscanf_s(s,"%d",&vectorScoli[i].x_pos);
		vectorScoli[i].x_pos = static_cast<int> (vectorScoli[i].x_pos * N/1000.); 
									 

		fgets(s,256,f);
		sscanf_s(s,"%d",&vectorScoli[i].y_pos);
		vectorScoli[i].y_pos = static_cast<int> (vectorScoli[i].y_pos*N/1000.);

		


		fgets(s,256,f);
		int k=0;
		while(s[0]!='#' && !feof(f) ) 
		{
			sscanf_s(s,"%d",&vectorScoli[i].vecini[k]);
			k++;
			fgets(s,256,f);
		};

		vectorScoli[i].nr_vecini = k;

		fgets(s,256,f);
		k=0;
		while(s[0]!='#' && !feof(f) ) 
		{
			sscanf_s(s,"%d",&vectorScoli[i].vertices[k]);
			k++;
			fgets(s,256,f);
		};

		vectorScoli[i].nr_vertices = k;
	}

	fclose(f);
	std::cout << "Done reading schools" << endl <<endl;
  return true;

};