#pragma once
#include <vector>

#define N 100

struct coord{
	int x_pos,y_pos;
};

class Scoala{
public:
	int x_pos, y_pos, nr_vecini, nr_vertices;
	int vecini[20], vertices[25];
	int nr_studenti, nr_albi, nr_maxim_studenti;
	double procent_albi;
	std::vector<coord> cartier;
};


typedef std::vector<Scoala> Scoli;



class SchoolsGenerator
{
public:
  SchoolsGenerator(const char* voronoiFileName): 
    _voronoiFileName(voronoiFileName){};

  bool generate();

  int getNumberOfSchools(){
    return vectorScoli.size();
  };

  Scoli getSchools(){
    return vectorScoli;
  };


private:
  std::string _voronoiFileName;
  Scoli  vectorScoli;
};