// schelling_model2.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <stdio.h>
#include <iomanip>
#include <vector>
#include <ctime>
#include <string>
#include "intarray2bmp.h"
#include "cartier.h"


using namespace std;

const double pondere_distanta = 3.2;//1;//3.2;
const double pondere_quality = 4.28;//0;//4.28;
const double pondere_segregare =3.05;//0;//3.05;

const double sigma_pondere_distanta = 0.8;//0.8;
const double sigma_pondere_quality = 1.2;//1.2;
const double sigma_pondere_segregare = 0.6;//0.6;

const double PI = 3.141592;



int _tmain(int argc, _TCHAR* argv[])
{
  //Scoli sc;
  //Agent ag[N][N], agent_schools[N][N];

  //int nr_agenti, nr_agenti_albi, nr_repetitii, nr_agenti_pe_ciclu, statistica;
  //double prag_satisfactie;

  //ofstream FinalTableStream;
  //FinalTableStream.open("final_table_T04_alpha05.txt");
  //FinalTableStream << "fa \t fb \t School_neighb \t Variable_neigh \t School_index" << endl;

  //for (double fa = 0.1; fa<1; fa+=0.2) {
  //  for (double fb = 0.1; fb<1; fb+=0.2) {

      char *file_name_scoli= "mesha2.txt";
      char *file_name_agenti = "agenti.txt";
      cartier wijk = cartier(file_name_scoli, file_name_agenti);
      FILE *f;

      //wijk.setFA(fa);
      //wijk.setFB(fb);

      cout <<"number of runs = " << wijk.statistica<<endl;
      cout << "Nr_agenti = " << wijk.nr_agenti << endl
        << "Nr_agenti_albi = " << wijk.nr_agenti_albi << endl;
        //<< " fa = " << fa << " fb = "<< fb << endl;

      
      cartier wijk_copy = cartier(wijk); 
      evArray meanRez, sigmaRez;

      wijk_copy.schelling("segregare_in_time.txt");
     
      meanRez.resize(wijk_copy.residential_stat.size());
      sigmaRez.resize(wijk_copy.residential_stat.size());
     
      for (int j=0; j<wijk_copy.residential_stat.size(); j++)
      {
        meanRez[j].pas = wijk_copy.residential_stat[j].pas;
        meanRez[j].value = wijk_copy.residential_stat[j].value;
        sigmaRez[j].pas = wijk_copy.residential_stat[j].pas;
        sigmaRez[j].value = wijk_copy.residential_stat[j].value*wijk_copy.residential_stat[j].value;
      }

      for (int i =1; i<wijk.statistica; i++)
      {
        cout<<i<<endl;
        wijk_copy = wijk; 
        wijk_copy.schelling("segregare_in_time.txt");
        wijk_copy.print_bmp(-1);
        for (int j=0; j<wijk_copy.residential_stat.size(); j++)
        {
          meanRez[j].value += wijk_copy.residential_stat[j].value;
          sigmaRez[j].value += wijk_copy.residential_stat[j].value*wijk_copy.residential_stat[j].value;
        }
      }

      f = fopen("Statisica_schelling.txt","w");
      fprintf(f,"pas_timp idice_segregare_mediu sigma\n");
      for (int j=0; j<wijk_copy.residential_stat.size(); j++)
      {
        meanRez[j].value /= wijk.statistica;
        sigmaRez[j].value = sigmaRez[j].value/wijk.statistica - meanRez[j].value*meanRez[j].value >0 ?
          sqrt(sigmaRez[j].value/wijk.statistica - meanRez[j].value*meanRez[j].value):0;
        fprintf(f,"%5d %10.7lf %10.7lf\n",meanRez[j].pas, meanRez[j].value, sigmaRez[j].value);
      }

      const double variableSchoolIndex = wijk_copy.indice_segregare_moore_total(wijk_copy.getRadiusMoore());
      fclose(f);

      
      wijk_copy.EportMapToOutputFile();

      

      cout<< "schelling done schools start"<<endl;

      wijk_copy = wijk; 
      wijk_copy.print_bmp(0);
      wijk_copy.segregare_scoli("segregare_scoli_in_time.txt");

      cout << "aici \n";

      evArray meanSch;
      evArray sigmaSch;
      meanSch.resize(wijk_copy.school_stat.size());
      sigmaSch.resize(wijk_copy.school_stat.size());
      for (int j=0; j<wijk_copy.school_stat.size(); j++)
      {
        meanSch[j].pas = wijk_copy.school_stat[j].pas;
        meanSch[j].value = wijk_copy.school_stat[j].value;
        sigmaSch[j].pas = wijk_copy.school_stat[j].pas;
        sigmaSch[j].value = wijk_copy.school_stat[j].value*wijk_copy.school_stat[j].value;
      }
      cout << "aici \n";
      for (int i =1; i<wijk.statistica; i++)
      {
        wijk_copy = wijk; 
        wijk_copy.segregare_scoli("segregare_scoli_in_time.txt");
        for (int j=0; j<wijk_copy.school_stat.size(); j++)
        {
          meanSch[j].value += wijk_copy.school_stat[j].value;
          sigmaSch[j].value += wijk_copy.school_stat[j].value*wijk_copy.school_stat[j].value;
        }
      }
      f = fopen("Statisica_scoli.txt","w");
      fprintf(f,"pas_timp idice_segregare_mediu sigmaSch\n");
      for (int j=0; j<wijk_copy.school_stat.size(); j++)
      {
        meanSch[j].value /= wijk.statistica;
        sigmaSch[j].value = sigmaSch[j].value/wijk.statistica-meanSch[j].value*meanSch[j].value >0 ? 
          sqrt(sigmaSch[j].value/wijk.statistica-meanSch[j].value*meanSch[j].value):0;
        fprintf(f,"%5d %10.7lf %10.7lf\n",meanSch[j].pas, meanSch[j].value, sigmaSch[j].value);
      }
      fclose(f);

  //    FinalTableStream << std::setw(10) << fa 
  //                     << std::setw(10) << fb 
  //                     << std::setw(15) << meanRez[meanSch.size()-1].value 
  //                     << std::setw(15) << variableSchoolIndex
  //                     << std::setw(15) << meanSch[meanSch.size()-1].value 
  //                     << endl;

  //  }
  //}

  //FinalTableStream.close();
  return 0;


}



